(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



BeginPackage["TwoAxisDateListPlot`"];

(* Exported symbols added here with SymbolName::usage *) 

TwoAxisDateListPlot::usage="TwoAxisDateListPlot[list1, list2, options] will generate a two axis DateListPlot, i.e. a plot with the left y-axis showing the y values of list1 and the right y-axis showing the y values of list2. \"options\" are the same as DateListPlot minus Axes related options, Frame, and Ticks and TicksStyle";


Unprotect[TwoAxisDateListPlot];

Begin["`Private`"];
(* Implementation of the package *)


Clear[TwoAxisDateListPlot];

SetAttributes[TwoAxisDateListPlot, ReadProtected];

SyntaxInformation[TwoAxisDateListPlot]={"ArgumentsPattern"->{_,_,OptionsPattern[]}};

Options[TwoAxisDateListPlot]=Join[Options[DateListPlot],{BarChart->False}];

SetOptions[TwoAxisDateListPlot,Joined->True];


makeTicks[data_List]:=Module[{divisions,tmp1,tmp2},
divisions=FindDivisions[{Min[data[[All,2]]],Max[data[[All,2]]]},{5,5}];
tmp1=N[{#,#,{0.00625,0.},{GrayLevel[0.`],AbsoluteThickness[0.125`]}}]&/@First[divisions];
tmp2=N[{#,"",{0.00375,0.},{GrayLevel[0.`],AbsoluteThickness[0.125`]}}]&/@Complement[Flatten[Rest[divisions]],First[divisions]];
Join[{{First@divisions[[1]],Last@divisions[[1]]}},tmp1,tmp2]
]


TwoAxisDateListPlot[line_List,bar_List,opts:OptionsPattern[]]:=Module[{plotStyleOptions=OptionValue[PlotStyle],userOptions,defaultOptions,color1,color2,leftTicks,rightTicks,tmp1,len,newTicks,plotRange,newBar,zero,bars,prolog,newPlotStyle},

(* get options *)
userOptions=FilterRules[{opts},Options[DateListPlot]];
defaultOptions=FilterRules[{Options[TwoAxisDateListPlot]},Options[DateListPlot]];

(* set colors for plot and left & right ticks *)
If[
plotStyleOptions===Automatic,
color1=ColorData[1,1];
color2=ColorData[1,2];,
color1=First@Flatten[{Cases[{First[plotStyleOptions]},_RGBColor|__GrayLevel|__Hue|__CMYKColor,\[Infinity]],ColorData[1,1]}];
color2=First@Flatten[{Cases[Rest[plotStyleOptions],_RGBColor|__GrayLevel|__Hue|__CMYKColor,\[Infinity]],ColorData[1,2]}];
];

(* extract ticks *)
leftTicks=makeTicks[line];
rightTicks=makeTicks[bar];

(* make new ticks and new scaled range and then color tick labels *)
newTicks=Apply[{Rescale[N@#1,First@rightTicks,First@leftTicks],##2}&,Rest@rightTicks,{1}];
newTicks=newTicks/.{x_,y_?NumericQ,a_,b_}:>{x,Style[y,color2],a,b};

(* rescale the bar data and find the zero *)
newBar=Apply[{#1,Rescale[#2,First@rightTicks,First@leftTicks]}&,bar,{1}];
zero=Rescale[0,First@rightTicks,First@leftTicks];
plotRange=First@leftTicks;
leftTicks=Rest@leftTicks/.{x_,y_?NumericQ,a_,b_}:>{x,Style[y,color1],a,b};

(* do bar calculation *)
If[OptionValue["BarChart"]==True,

(* work out new plot styles *)
Which[
plotStyleOptions===Automatic,newPlotStyle={Automatic,Opacity[0]},
Length[plotStyleOptions]<=1,newPlotStyle=Flatten@{plotStyleOptions,Opacity[0]},
Length[plotStyleOptions]>1,newPlotStyle={plotStyleOptions[[1]],Flatten[{plotStyleOptions[[2]],Opacity[0]}]};
];

(* assume data is dated the end of the month. Add a start of month date for the rectangle x coordinates *)
bars=Rectangle[{AbsoluteTime[{#[[1,1]],#[[1,2]],1}],Min[{zero,#[[2]]}]},{AbsoluteTime[#[[1]]],Max[{zero,#[[2]]}]}]&/@newBar;

(* prolog options to make the bars to display in the plot *)
prolog={color2,EdgeForm[Directive[Thin,White]],bars};,

(* else BarChart->False *)
newPlotStyle=plotStyleOptions;
prolog={};
];

DateListPlot[{line,newBar},
Axes->True,
AxesOrigin->{Automatic,zero},
Prolog->prolog,
Frame->True,
FrameTicks->{Automatic,newTicks,Automatic,leftTicks},
PlotRange->{Automatic,plotRange},
PlotStyle->newPlotStyle,
userOptions,
defaultOptions
]
]


End[];

Protect[TwoAxisDateListPlot];

EndPackage[]


(* some monthly bar data *)

barData={{{2008,2,29},136243},{{2008,3,31},126421},{{2008,4,30},127977},{{2008,5,31},94196},{{2008,6,30},75707},{{2008,7,31},-88075},{{2008,8,31},87168},{{2008,9,30},112187},{{2008,10,31},-128929},{{2008,11,30},141728},{{2008,12,31},211527},{{2009,1,31},180490},{{2009,2,28},-270948},{{2009,3,31},296843},{{2009,4,30},317947},{{2009,5,31},337230},{{2009,6,30},378943},{{2009,7,31},292226},{{2009,8,31},-219731},{{2009,9,30},282828},{{2009,10,31},169374},{{2009,11,30},244013}};


apple=FinancialData["AAPL",DatePlus[-720]];
dow=FinancialData["^DJI",DatePlus[-720]];



